diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/tgax-virtual-desktop.cc ns-3.47/src/applications/model/tgax-virtual-desktop.cc
--- ns-3.46/src/applications/model/tgax-virtual-desktop.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/applications/model/tgax-virtual-desktop.cc	2026-02-16 16:08:49.571229700 -0800
@@ -0,0 +1,308 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "tgax-virtual-desktop.h"
+
+#include "ns3/attribute-container.h"
+#include "ns3/double.h"
+#include "ns3/enum.h"
+#include "ns3/inet-socket-address.h"
+#include "ns3/inet6-socket-address.h"
+#include "ns3/log.h"
+#include "ns3/node.h"
+#include "ns3/nstime.h"
+#include "ns3/packet-socket-address.h"
+#include "ns3/packet.h"
+#include "ns3/pair.h"
+#include "ns3/pointer.h"
+#include "ns3/random-variable-stream.h"
+#include "ns3/simulator.h"
+#include "ns3/socket-factory.h"
+#include "ns3/socket.h"
+#include "ns3/string.h"
+
+#include <cmath>
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("TgaxVirtualDesktop");
+
+NS_OBJECT_ENSURE_REGISTERED(TgaxVirtualDesktop);
+
+TypeId
+TgaxVirtualDesktop::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::TgaxVirtualDesktop")
+            .SetParent<SourceApplication>()
+            .SetGroupName("Applications")
+            .AddConstructor<TgaxVirtualDesktop>()
+            .AddAttribute("ModelPresets",
+                          "The model presets to use (Custom for custom settings)",
+                          TypeId::ATTR_GET |
+                              TypeId::ATTR_CONSTRUCT, // prevent setting after construction
+                          EnumValue(TgaxVirtualDesktop::ModelPresets::CUSTOM),
+                          MakeEnumAccessor<ModelPresets>(&TgaxVirtualDesktop::m_modelPresets),
+                          MakeEnumChecker(TgaxVirtualDesktop::ModelPresets::CUSTOM,
+                                          "Custom",
+                                          TgaxVirtualDesktop::ModelPresets::DOWNLINK,
+                                          "Downlink",
+                                          TgaxVirtualDesktop::ModelPresets::UPLINK,
+                                          "Uplink"))
+            .AddAttribute(
+                "Protocol",
+                "The type of protocol to use. This should be a subclass of ns3::SocketFactory",
+                TypeIdValue(TypeId::LookupByName("ns3::TcpSocketFactory")),
+                MakeTypeIdAccessor(&TgaxVirtualDesktop::m_protocolTid),
+                MakeTypeIdChecker())
+            .AddAttribute(
+                "CustomInitialPacketArrival",
+                "A uniform random variable to generate the initial packet arrival in nanoseconds.",
+                StringValue("ns3::UniformRandomVariable[Min=0|Max=20000000]"),
+                MakePointerAccessor(&TgaxVirtualDesktop::m_initialArrivalUniform),
+                MakePointerChecker<UniformRandomVariable>())
+            .AddAttribute("CustomInterPacketArrivals",
+                          "An exponential random variable to generate the inter packet arrivals in "
+                          "nanoseconds.",
+                          StringValue("ns3::ExponentialRandomVariable[Mean=60226900]"),
+                          MakePointerAccessor(&TgaxVirtualDesktop::m_interArrivalExponential),
+                          MakePointerChecker<ExponentialRandomVariable>())
+            .AddAttribute(
+                "CustomParametersPacketSize",
+                "The mean value and standard deviation for each mode of the multimodal normal "
+                "distribution used to calculate packet sizes.",
+                StringValue("41.0 3.2;1478.3 11.6"),
+                MakeAttributeContainerAccessor<PairValue<DoubleValue, DoubleValue>, ';'>(
+                    &TgaxVirtualDesktop::SetParametersPacketSize),
+                MakeAttributeContainerChecker<PairValue<DoubleValue, DoubleValue>, ';'>(
+                    MakePairChecker<DoubleValue, DoubleValue>(MakeDoubleChecker<double>(),
+                                                              MakeDoubleChecker<double>())));
+    return tid;
+}
+
+TgaxVirtualDesktop::TgaxVirtualDesktop()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+TgaxVirtualDesktop::~TgaxVirtualDesktop()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+int64_t
+TgaxVirtualDesktop::AssignStreams(int64_t stream)
+{
+    NS_LOG_FUNCTION(this << stream);
+    auto currentStream = stream;
+    m_initialArrivalUniform->SetStream(currentStream++);
+    m_interArrivalExponential->SetStream(currentStream++);
+    if (m_pktSizeDistributions.size() > 1)
+    {
+        m_dlModeSelection->SetStream(currentStream++);
+    }
+    for (auto& pktSizeDistribution : m_pktSizeDistributions)
+    {
+        pktSizeDistribution->SetStream(currentStream++);
+    }
+    return (currentStream - stream);
+}
+
+void
+TgaxVirtualDesktop::SetParametersPacketSize(const std::vector<std::pair<double, double>>& params)
+{
+    m_pktSizeDistributions.clear();
+    NS_LOG_FUNCTION(this << params.size());
+    for (const auto& [mean, std] : params)
+    {
+        auto normal = CreateObject<NormalRandomVariable>();
+        normal->SetAttribute("Mean", DoubleValue(mean));
+        normal->SetAttribute("Variance", DoubleValue(std::pow(std, 2)));
+        m_pktSizeDistributions.push_back(normal);
+    }
+    if ((m_pktSizeDistributions.size() > 1) && !m_dlModeSelection)
+    {
+        m_dlModeSelection =
+            CreateObjectWithAttributes<BernoulliRandomVariable>("Probability",
+                                                                DoubleValue(22.4 / 76.1));
+    }
+}
+
+void
+TgaxVirtualDesktop::DoInitialize()
+{
+    NS_LOG_FUNCTION(this);
+    SourceApplication::DoInitialize();
+
+    if (m_modelPresets != ModelPresets::CUSTOM)
+    {
+        std::vector<std::pair<double, double>> params;
+        if (m_modelPresets == ModelPresets::DOWNLINK)
+        {
+            // Downlink model presets
+            params = {{41.0, 3.2}, {1478.3, 11.6}};
+            m_initialArrivalUniform->SetAttribute("Min", DoubleValue(0.0));
+            m_initialArrivalUniform->SetAttribute("Max", DoubleValue(20000000.0));
+            m_interArrivalExponential->SetAttribute("Mean", DoubleValue(60226900.0));
+        }
+        else if (m_modelPresets == ModelPresets::UPLINK)
+        {
+            // Uplink model presets
+            params = {{50.598, 5.0753}};
+            m_initialArrivalUniform->SetAttribute("Min", DoubleValue(0.0));
+            m_initialArrivalUniform->SetAttribute("Max", DoubleValue(20000000.0));
+            m_interArrivalExponential->SetAttribute("Mean", DoubleValue(48287000.0));
+        }
+        SetParametersPacketSize(params);
+    }
+}
+
+void
+TgaxVirtualDesktop::DoStartApplication()
+{
+    NS_LOG_FUNCTION(this);
+
+    m_socket->SetDataSentCallback(MakeCallback(&TgaxVirtualDesktop::TxDone, this));
+    m_socket->SetSendCallback(MakeCallback(&TgaxVirtualDesktop::TxAvailable, this));
+    m_socket->SetAllowBroadcast(true);
+    m_socket->ShutdownRecv();
+
+    if (m_connected)
+    {
+        ScheduleNext();
+    }
+}
+
+void
+TgaxVirtualDesktop::CancelEvents()
+{
+    NS_LOG_FUNCTION(this);
+    m_txEvent.Cancel();
+    if (m_unsentPacket)
+    {
+        NS_LOG_DEBUG("Discarding cached packet upon CancelEvents ()");
+    }
+    m_unsentPacket = nullptr;
+    m_initialPacket = true;
+}
+
+Time
+TgaxVirtualDesktop::GetInterArrival() const
+{
+    if (m_unsentPacket)
+    {
+        return Time();
+    }
+    if (m_initialPacket)
+    {
+        return NanoSeconds(m_initialArrivalUniform->GetValue());
+    }
+    return NanoSeconds(m_interArrivalExponential->GetValue());
+}
+
+uint32_t
+TgaxVirtualDesktop::GetPacketSize() const
+{
+    const auto mode = (m_pktSizeDistributions.size() > 1) ? m_dlModeSelection->GetValue() : 0;
+    return m_pktSizeDistributions.at(mode)->GetValue();
+}
+
+void
+TgaxVirtualDesktop::ScheduleNext()
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT(!m_txEvent.IsPending());
+    m_txEvent = Simulator::Schedule(GetInterArrival(), &TgaxVirtualDesktop::SendPacket, this);
+}
+
+void
+TgaxVirtualDesktop::SendPacket()
+{
+    NS_LOG_FUNCTION(this);
+
+    NS_ASSERT(m_txEvent.IsExpired());
+
+    Ptr<Packet> packet;
+    if (m_unsentPacket)
+    {
+        packet = m_unsentPacket;
+    }
+    else
+    {
+        packet = Create<Packet>(GetPacketSize());
+    }
+
+    unsigned int actualSize = m_socket->Send(packet);
+    if (actualSize == packet->GetSize())
+    {
+        m_txTrace(packet);
+        m_unsentPacket = nullptr;
+        Address localAddress;
+        m_socket->GetSockName(localAddress);
+        if (InetSocketAddress::IsMatchingType(m_peer))
+        {
+            NS_LOG_INFO("At time " << Simulator::Now().As(Time::S) << " VDI traffic source sent "
+                                   << (m_initialPacket ? "initial packet of " : "packet of ")
+                                   << packet->GetSize() << " bytes to "
+                                   << InetSocketAddress::ConvertFrom(m_peer).GetIpv4() << " port "
+                                   << InetSocketAddress::ConvertFrom(m_peer).GetPort());
+        }
+        else if (Inet6SocketAddress::IsMatchingType(m_peer))
+        {
+            NS_LOG_INFO("At time " << Simulator::Now().As(Time::S) << " VDI traffic source sent "
+                                   << (m_initialPacket ? "initial packet of " : "packet of ")
+                                   << packet->GetSize() << " bytes to "
+                                   << Inet6SocketAddress::ConvertFrom(m_peer).GetIpv6() << " port "
+                                   << Inet6SocketAddress::ConvertFrom(m_peer).GetPort());
+        }
+    }
+    else
+    {
+        NS_LOG_DEBUG("Unable to send VDI packet; actual " << actualSize << " size "
+                                                          << packet->GetSize()
+                                                          << "; caching for later attempt");
+        m_unsentPacket = packet;
+    }
+
+    if (m_initialPacket)
+    {
+        m_initialPacket = false;
+    }
+
+    ScheduleNext();
+}
+
+void
+TgaxVirtualDesktop::DoConnectionSucceeded(Ptr<Socket> socket)
+{
+    NS_LOG_FUNCTION(this << socket);
+    ScheduleNext();
+}
+
+void
+TgaxVirtualDesktop::TxDone(Ptr<Socket> socket, uint32_t size)
+{
+    NS_LOG_FUNCTION(this << socket << size);
+    if (m_unsentPacket)
+    {
+        ScheduleNext();
+    }
+}
+
+void
+TgaxVirtualDesktop::TxAvailable(Ptr<Socket> socket, uint32_t available)
+{
+    NS_LOG_FUNCTION(this << socket << available);
+    if (m_unsentPacket)
+    {
+        ScheduleNext();
+    }
+}
+
+} // Namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/tgax-virtual-desktop.h ns-3.47/src/applications/model/tgax-virtual-desktop.h
--- ns-3.46/src/applications/model/tgax-virtual-desktop.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/applications/model/tgax-virtual-desktop.h	2026-02-16 16:08:49.571229700 -0800
@@ -0,0 +1,140 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef TGAX_VIRTUAL_DESKTOP_H
+#define TGAX_VIRTUAL_DESKTOP_H
+
+#include "source-application.h"
+
+#include "ns3/address.h"
+#include "ns3/event-id.h"
+#include "ns3/ptr.h"
+
+#include <utility>
+#include <vector>
+
+namespace ns3
+{
+
+class ExponentialRandomVariable;
+class UniformRandomVariable;
+class BernoulliRandomVariable;
+class NormalRandomVariable;
+
+/**
+ * @ingroup applications
+ * @brief Generate Virtual Desktop Infrastructure (VDI) traffic.
+ *
+ * This VDI traffic generator follows requirements from IEEE 802.11-14/0571r12 - 11ax Evaluation
+ * Methodology (Appendix 2 – Traffic model descriptions: Virtual Desktop Infrastructure Traffic
+ * Model) (see applications documentation for full citation).
+ *
+ * In this model, desktop application packet arrival interval obeys an exponential distribution and
+ * packet size obeys a normal distribution.
+ */
+class TgaxVirtualDesktop : public SourceApplication
+{
+  public:
+    /**
+     * @brief Get the type ID.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    TgaxVirtualDesktop();
+    ~TgaxVirtualDesktop() override;
+
+    /// Model presets enumeration
+    enum class ModelPresets : uint8_t
+    {
+        CUSTOM = 0, //< Custom traffic model (by default, load parameters of DL model presets)
+        DOWNLINK,   //< DL model presets
+        UPLINK      //< UL model presets
+    };
+
+    int64_t AssignStreams(int64_t stream) override;
+
+  protected:
+    void DoInitialize() override;
+
+  private:
+    void DoStartApplication() override;
+    void DoConnectionSucceeded(Ptr<Socket> socket) override;
+    void CancelEvents() override;
+
+    /**
+     * @brief Set the parameters of the normal random variable used to generate the VDI packet
+     * sizes.
+     *
+     * @param params a vector of pairs (mean, standard deviation) for each mode of the normal
+     * distribution used to generate the VDI packet sizes
+     */
+    void SetParametersPacketSize(const std::vector<std::pair<double, double>>& params);
+
+    /**
+     * @brief Get the duration to use to schedule the TX of the next VDI packet.
+     *
+     * @return Get the duration to use to schedule the TX of the next VDI packet
+     */
+    Time GetInterArrival() const;
+
+    /**
+     * @brief Get the size in bytes of the next VDI packet to send.
+     *
+     * @return Get the size in bytes of the next VDI packet to send
+     */
+    uint32_t GetPacketSize() const;
+
+    /**
+     * Schedule the next TX
+     */
+    void ScheduleNext();
+
+    /**
+     * Transmit the next VDI packet
+     */
+    void SendPacket();
+
+    /**
+     * Handle a Data Sent event
+     *
+     * @param socket the connected socket
+     * @param size the amount of transmitted bytes
+     */
+    void TxDone(Ptr<Socket> socket, uint32_t size);
+
+    /**
+     * Handle a Send event
+     *
+     * @param socket the connected socket
+     * @param available the amount of available bytes for transmission
+     */
+    void TxAvailable(Ptr<Socket> socket, uint32_t available);
+
+    bool m_initialPacket{true}; //!< True if the next packet to send is the initial packet
+
+    ModelPresets
+        m_modelPresets; //!< Model presets to use to configure the VDI traffic model parameters
+    Ptr<UniformRandomVariable> m_initialArrivalUniform; //!< Uniform random variable to generate
+                                                        //!< initial packet arrival in nanoseconds
+    Ptr<ExponentialRandomVariable>
+        m_interArrivalExponential; //!< Exponential random variable to generate packet arrival times
+                                   //!< in nanoseconds
+    Ptr<BernoulliRandomVariable> m_dlModeSelection; //!< Uniform random variable to select mode for
+                                                    //!< downlink bimodal distribution
+    std::vector<Ptr<NormalRandomVariable>>
+        m_pktSizeDistributions; //!< Single or multi modal normal random variables to generate
+                                //!< packet sizes in bytes
+
+    EventId m_txEvent;          //!< Event id of pending TX event
+    Ptr<Packet> m_unsentPacket; //!< Unsent packet cached for future attempt
+};
+
+} // namespace ns3
+
+#endif /* TGAX_VIRTUAL_DESKTOP_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/tgax-voip-traffic.cc ns-3.47/src/applications/model/tgax-voip-traffic.cc
--- ns-3.46/src/applications/model/tgax-voip-traffic.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/applications/model/tgax-voip-traffic.cc	2026-02-16 16:08:49.571229700 -0800
@@ -0,0 +1,362 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "tgax-voip-traffic.h"
+
+#include "ns3/double.h"
+#include "ns3/inet-socket-address.h"
+#include "ns3/inet6-socket-address.h"
+#include "ns3/log.h"
+#include "ns3/node.h"
+#include "ns3/nstime.h"
+#include "ns3/packet-socket-address.h"
+#include "ns3/packet.h"
+#include "ns3/random-variable-stream.h"
+#include "ns3/simulator.h"
+#include "ns3/socket-factory.h"
+#include "ns3/socket.h"
+#include "ns3/uinteger.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("TgaxVoipTraffic");
+
+NS_OBJECT_ENSURE_REGISTERED(TgaxVoipTraffic);
+
+TypeId
+TgaxVoipTraffic::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::TgaxVoipTraffic")
+            .SetParent<SourceApplication>()
+            .SetGroupName("Applications")
+            .AddConstructor<TgaxVoipTraffic>()
+            .AddAttribute(
+                "Protocol",
+                "The type of protocol to use. This should be a subclass of ns3::SocketFactory",
+                TypeId::ATTR_GET | TypeId::ATTR_CONSTRUCT, // prevent setting after construction
+                TypeIdValue(TypeId::LookupByName("ns3::PacketSocketFactory")),
+                MakeTypeIdAccessor(&TgaxVoipTraffic::m_protocolTid),
+                MakeTypeIdChecker())
+            .AddAttribute(
+                "ActivePacketPayloadSize",
+                "Size in bytes for payload of packets generated during periods of active talking.",
+                UintegerValue(33),
+                MakeUintegerAccessor(&TgaxVoipTraffic::m_activePacketSize),
+                MakeUintegerChecker<uint32_t>())
+            .AddAttribute(
+                "SilencePacketPayloadSize",
+                "Size in bytes for payload of packets generated during periods of silence.",
+                UintegerValue(7),
+                MakeUintegerAccessor(&TgaxVoipTraffic::m_silencePacketSize),
+                MakeUintegerChecker<uint32_t>())
+            .AddAttribute("MeanActiveStateDuration",
+                          "Mean duration of active/talking state.",
+                          TimeValue(MilliSeconds(1250)),
+                          MakeTimeAccessor(&TgaxVoipTraffic::SetActiveExponentialMean),
+                          MakeTimeChecker())
+            .AddAttribute("MeanInactiveStateDuration",
+                          "Mean duration of inactive/silence state.",
+                          TimeValue(MilliSeconds(1250)),
+                          MakeTimeAccessor(&TgaxVoipTraffic::SetInactiveExponentialMean),
+                          MakeTimeChecker())
+            .AddAttribute("VoiceEncoderInterval",
+                          "Interval between generation of voice packets.",
+                          TimeValue(MilliSeconds(20)),
+                          MakeTimeAccessor(&TgaxVoipTraffic::m_voiceInterval),
+                          MakeTimeChecker())
+            .AddAttribute("SilenceEncoderInterval",
+                          "Interval between generation of silence packets. "
+                          "This implementation requires the value of this attribute to be a "
+                          "multiple of VoiceEncoderInterval",
+                          TimeValue(MilliSeconds(160)),
+                          MakeTimeAccessor(&TgaxVoipTraffic::m_silenceInterval),
+                          MakeTimeChecker())
+            .AddAttribute(
+                "VoiceToSilenceProbability",
+                "The probability to transition from active talking state to silence state.",
+                DoubleValue(0.016),
+                MakeDoubleAccessor(&TgaxVoipTraffic::m_activeToInactive),
+                MakeDoubleChecker<double>(0, 1))
+            .AddAttribute(
+                "SilenceToVoiceProbability",
+                "The probability to transition from silence state to active talking state.",
+                DoubleValue(0.016),
+                MakeDoubleAccessor(&TgaxVoipTraffic::m_inactiveToActive),
+                MakeDoubleChecker<double>(0, 1))
+            .AddAttribute("ScaleDelayJitter",
+                          "Scale of laplacian distribution used to calculate delay jitter for "
+                          "generated packets.",
+                          TimeValue(MicroSeconds(5110)),
+                          MakeTimeAccessor(&TgaxVoipTraffic::m_delayJitterScale),
+                          MakeTimeChecker())
+            .AddAttribute("BoundDelayJitter",
+                          "Bound of laplacian distribution used to calculate delay jitter for "
+                          "generated packets. For no jitter, set this attribute to zero.",
+                          TimeValue(MilliSeconds(80)),
+                          MakeTimeAccessor(&TgaxVoipTraffic::m_delayJitterBound),
+                          MakeTimeChecker())
+            .AddTraceSource(
+                "TxWithJitter",
+                "A VoIP packet is sent, this trace also reports the jitter applied to the packet",
+                MakeTraceSourceAccessor(&TgaxVoipTraffic::m_txJitterTrace),
+                "ns3::TgaxVoipTraffic::TxTracedCallback")
+            .AddTraceSource("StateUpdate",
+                            "Voice activity state updated",
+                            MakeTraceSourceAccessor(&TgaxVoipTraffic::m_stateUpdate),
+                            "ns3::TgaxVoipTraffic::StateUpdatedCallback");
+    return tid;
+}
+
+TgaxVoipTraffic::TgaxVoipTraffic()
+    : m_inactiveExponential{CreateObject<ExponentialRandomVariable>()},
+      m_activeExponential{CreateObject<ExponentialRandomVariable>()},
+      m_inactiveUniform{CreateObject<UniformRandomVariable>()},
+      m_activeUniform{CreateObject<UniformRandomVariable>()},
+      m_delayJitterLaplacian{CreateObject<LaplacianRandomVariable>()}
+{
+    NS_LOG_FUNCTION(this);
+}
+
+TgaxVoipTraffic::~TgaxVoipTraffic()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+int64_t
+TgaxVoipTraffic::AssignStreams(int64_t stream)
+{
+    NS_LOG_FUNCTION(this << stream);
+    auto currentStream = stream;
+    m_inactiveExponential->SetStream(currentStream++);
+    m_activeExponential->SetStream(currentStream++);
+    m_inactiveUniform->SetStream(currentStream++);
+    m_activeUniform->SetStream(currentStream++);
+    m_delayJitterLaplacian->SetStream(currentStream++);
+    return (currentStream - stream);
+}
+
+void
+TgaxVoipTraffic::DoInitialize()
+{
+    NS_LOG_FUNCTION(this);
+    SourceApplication::DoInitialize();
+    m_delayJitterLaplacian->SetAttribute("Scale",
+                                         DoubleValue(m_delayJitterScale.GetMicroSeconds()));
+    m_delayJitterLaplacian->SetAttribute("Bound",
+                                         DoubleValue(m_delayJitterBound.GetMicroSeconds()));
+}
+
+void
+TgaxVoipTraffic::SetActiveExponentialMean(Time mean)
+{
+    NS_LOG_FUNCTION(this << mean);
+    m_activeExponential->SetAttribute("Mean", DoubleValue(mean.GetMilliSeconds()));
+}
+
+void
+TgaxVoipTraffic::SetInactiveExponentialMean(Time mean)
+{
+    NS_LOG_FUNCTION(this << mean);
+    m_inactiveExponential->SetAttribute("Mean", DoubleValue(mean.GetMilliSeconds()));
+}
+
+void
+TgaxVoipTraffic::DoStartApplication()
+{
+    NS_LOG_FUNCTION(this);
+
+    m_socket->SetAllowBroadcast(true);
+    m_socket->ShutdownRecv();
+
+    if (m_connected)
+    {
+        ScheduleNext();
+    }
+}
+
+void
+TgaxVoipTraffic::CancelEvents()
+{
+    NS_LOG_FUNCTION(this);
+    for (auto& event : m_txPacketEvents)
+    {
+        event.second.Cancel();
+    }
+    m_txPacketEvents.clear();
+    m_stateUpdateEvent.Cancel();
+    m_remainingEncodingDuration = GetEncoderFrameDuration();
+}
+
+Time
+TgaxVoipTraffic::GetEncoderFrameDuration() const
+{
+    return (m_currentState == VoiceActivityState::ACTIVE_TALKING) ? m_voiceInterval
+                                                                  : m_silenceInterval;
+}
+
+Time
+TgaxVoipTraffic::GetStateUpdateInterval() const
+{
+    NS_ABORT_MSG_IF(
+        !(m_silenceInterval % m_voiceInterval).IsZero(),
+        "Silence encoder frame duration should be a multiple of voice encoder frame duration");
+    return m_voiceInterval;
+}
+
+void
+TgaxVoipTraffic::ScheduleNext()
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT(!m_stateUpdateEvent.IsPending());
+    m_stateUpdateEvent =
+        Simulator::Schedule(GetStateUpdateInterval(), &TgaxVoipTraffic::UpdateState, this);
+}
+
+void
+TgaxVoipTraffic::SendPacket(uint64_t eventId, Ptr<Packet> packet, Time jitter)
+{
+    const auto size = packet->GetSize();
+    NS_LOG_FUNCTION(this << eventId << size << jitter);
+
+    auto it = m_txPacketEvents.find(eventId);
+    NS_ASSERT(it != m_txPacketEvents.end());
+    NS_ASSERT(it->second.IsExpired());
+
+    const auto actualSize = static_cast<uint32_t>(m_socket->Send(packet));
+    NS_ABORT_IF(actualSize != size);
+    m_txTrace(packet);
+    m_txJitterTrace(packet, jitter);
+
+    if (InetSocketAddress::IsMatchingType(m_peer))
+    {
+        NS_LOG_INFO("At time " << Simulator::Now().As(Time::S) << " voip traffic source sent "
+                               << size << " bytes to "
+                               << InetSocketAddress::ConvertFrom(m_peer).GetIpv4() << " port "
+                               << InetSocketAddress::ConvertFrom(m_peer).GetPort());
+    }
+    else if (Inet6SocketAddress::IsMatchingType(m_peer))
+    {
+        NS_LOG_INFO("At time " << Simulator::Now().As(Time::S) << " voip traffic source sent "
+                               << size << " bytes to "
+                               << Inet6SocketAddress::ConvertFrom(m_peer).GetIpv6() << " port "
+                               << Inet6SocketAddress::ConvertFrom(m_peer).GetPort());
+    }
+
+    m_txPacketEvents.erase(it);
+}
+
+void
+TgaxVoipTraffic::UpdateState()
+{
+    NS_LOG_FUNCTION(this);
+
+    m_remainingStateDuration -= GetStateUpdateInterval();
+    m_remainingEncodingDuration -= GetStateUpdateInterval();
+    NS_ASSERT(!m_remainingEncodingDuration.IsStrictlyNegative());
+
+    auto newState = m_currentState;
+    if (m_currentState == VoiceActivityState::INACTIVE_SILENCE)
+    {
+        if (m_inactiveUniform->GetValue() >= (1 - m_inactiveToActive))
+        {
+            newState = VoiceActivityState::ACTIVE_TALKING;
+        }
+    }
+    else
+    {
+        if (m_activeUniform->GetValue() >= (1 - m_activeToInactive))
+        {
+            newState = VoiceActivityState::INACTIVE_SILENCE;
+        }
+    }
+    m_pendingStateTransition = m_pendingStateTransition || (newState != m_currentState);
+
+    if (!m_remainingStateDuration.IsStrictlyPositive() && m_remainingEncodingDuration.IsZero())
+    {
+        if (m_pendingStateTransition)
+        {
+            newState = (m_currentState == VoiceActivityState::ACTIVE_TALKING)
+                           ? VoiceActivityState::INACTIVE_SILENCE
+                           : VoiceActivityState::ACTIVE_TALKING;
+        }
+        m_remainingStateDuration = (newState == VoiceActivityState::ACTIVE_TALKING)
+                                       ? MilliSeconds(m_activeExponential->GetValue())
+                                       : MilliSeconds(m_inactiveExponential->GetValue());
+        m_stateUpdate(newState, m_remainingStateDuration);
+        if ((newState != m_currentState))
+        {
+            NS_LOG_INFO("At time " << Simulator::Now().As(Time::S)
+                                   << " voip voice activity state changed from " << m_currentState
+                                   << " to " << newState << " for "
+                                   << m_remainingStateDuration.As(Time::MS));
+            m_currentState = newState;
+        }
+        else
+        {
+            NS_LOG_INFO("At time " << Simulator::Now().As(Time::S)
+                                   << " voip voice activity state unchanged to " << m_currentState
+                                   << " for " << m_remainingStateDuration.As(Time::MS));
+        }
+        m_pendingStateTransition = false;
+    }
+
+    if (m_remainingEncodingDuration.IsZero())
+    {
+        m_remainingEncodingDuration = GetEncoderFrameDuration();
+        auto delay = GetEncoderFrameDuration();
+        Time jitter{};
+        if (!m_delayJitterBound.IsZero())
+        {
+            jitter = MicroSeconds(static_cast<int64x64_t>(m_delayJitterLaplacian->GetValue()));
+            // Add the bound to always have a positive value as suggested in Robert Novak et al.,
+            // "Downlink VoIP Packet Delay Jitter Model".
+            delay += jitter + m_delayJitterBound;
+        }
+        const auto payloadSize = (m_currentState == VoiceActivityState::ACTIVE_TALKING)
+                                     ? m_activePacketSize
+                                     : m_silencePacketSize;
+        auto packet = Create<Packet>(payloadSize);
+        m_txPacketEvents[m_nextEventId] = Simulator::Schedule(delay,
+                                                              &TgaxVoipTraffic::SendPacket,
+                                                              this,
+                                                              m_nextEventId,
+                                                              packet,
+                                                              jitter);
+        ++m_nextEventId;
+    }
+
+    ScheduleNext();
+}
+
+void
+TgaxVoipTraffic::DoConnectionSucceeded(Ptr<Socket> socket)
+{
+    NS_LOG_FUNCTION(this << socket);
+    ScheduleNext();
+}
+
+std::ostream&
+operator<<(std::ostream& os, TgaxVoipTraffic::VoiceActivityState state)
+{
+    switch (state)
+    {
+    case TgaxVoipTraffic::VoiceActivityState::INACTIVE_SILENCE:
+        os << "Silence";
+        break;
+    case TgaxVoipTraffic::VoiceActivityState::ACTIVE_TALKING:
+        os << "Active talking";
+        break;
+    default:
+        NS_FATAL_ERROR("Unknown voice activity state");
+    }
+    return os;
+}
+
+} // Namespace ns3
